Subject: Re: Bug: bad errno report from lock_ref_sha1_basic() when contents bad

From: Thomas Rast <[email-masked]>
Date: Mon, 2 Apr 2012 20:12:05 +0200

Junio C Hamano <[email-masked]> writes:

> Thomas Rast <[email-masked]> writes:
>
>> But in general, the "errno may
>> be crucial or worthless" interface of lock_ref_sha1_basic() seems a bit
>> broken...
>
> Sorry, but I am not sure what you mean by this.  The function is fairly
> careful using errno to base its decision and even saves errno when it
> calls helpers that may overwrite it, so the "interface" does not want "may
> be crucial or worthless".  The implementation may have been broken over
> time by many patches, but that is a different issue.  Which codepaths
> clobber errno, and is it something you can easily fix with a patch or two?

I meant something else, sorry for being so unclear and confused.  In
particular my comment was supposed to be about resolve_ref_unsafe().

It has two different failure modes:

* Some FS syscall went wrong, and errno is crucial for the user to debug
  it (e.g., ENOENT).

* Reading went fine, but we failed to parse the resulting buffer.  errno
  has some unknown value.

The user of the function needs to be aware of this distinction, and
handle it accordingly.  Otherwise it risks emitting outright wrong error
messages, e.g., in my case I got

  thomas@thomas:~/g(next u+107)$ echo garbage >.git/refs/remotes/origin/master
  thomas@thomas:~/g(next u+107)$ g fetch
  error: unable to resolve reference refs/remotes/origin/master: No such file or directory
  From git://git.kernel.org/pub/scm/git/git
   ! [new branch]      master     -> origin/master  (unable to update local ref)

(The IRC user who asked about this was lucky because "Success"
immediately told us that it was an error path not related to syscalls.)

-- 
Thomas Rast
trast@{inf,student}.ethz.ch